*
      SUBROUTINE CAZ_GESV(NAME, TRANS, N, NPROW, NPCOL, AMEM,MEMSIZE,
     $                    NB, INFILEA, INFILEB, OUTFILE)
*
*     
* (PZGESV, PZGESV1, PZGESV2, PZGESV3)
*         
*
      include 'mpif.h'
*
*  
      INTEGER            N, NPROW, NPCOL, NB, MEMSIZE
      DOUBLE COMPLEX     AMEM( MEMSIZE )
      CHARACTER*(*)      INFILEA, INFILEB, OUTFILE, NAME, TRANS
*
*   -  
      INTEGER            NOUT, NIN, NPR
      PARAMETER          ( NOUT =13, NIN = 11, NPR = 6 )
*
*  
      INTEGER            CTXT, I, IAM, INFO, IPA, IPB, IPX, IPW,
     $                   IPPIV, IPAF, IPFER, IPBER, IPWOR, IPIWOR,
     $                   MYCOL, MYROW, NP, NQ,
     $                   NBRHS, NRHS, NQRHS, LWORK, LIWORK,
     $                   IA, JA, IB, JB, IAF, JAF, IX, JX,
     $                   NPROCS, MMIN, WORKSIZ
*
*  
      INTEGER            DESCA( 9), DESCB( 9), DESCX( 9), DESCAF( 9)
*
*  
      INTEGER            ICEIL, ILCM, NUMROC
      DOUBLE PRECISION   PDLAMCH
      EXTERNAL           ICEIL, ILCM, NUMROC, PDLAMCH
*
*  
      EXTERNAL           BLACS_EXIT, BLACS_GET, BLACS_GRIDEXIT,
     $                   BLACS_GRIDINFO, BLACS_GRIDINIT, BLACS_PINFO,
     $                   BLACS_SETUP, DESCINIT, PZLAPRNT, PZLAREAD,
     $                   PZLAWRITE,
     $                   PZGESV, PZGESV1, PZGESV2, PZGESV3
*
*  
*
*  
*
**      NPROCS = NPROW*NPCOL
      IA = 1
      JA = 1
      IB = 1
      JB = 1
      IAF = 1
      JAF = 1
      IX = 1
      JX = 1
      NRHS = 1
*?
      NBRHS = 1
*
*   BLACS
*
      CALL BLACS_PINFO( IAM, NPROCS )
*
        IF( NPROCS.LT.1 ) THEN
           CALL BLACS_SETUP( IAM, NPROCS )
*           CALL BLACS_SETUP( IAM, NPROW*NPCOL )
        END IF
*
*   BLACS'   
*
      CALL BLACS_GET( -1, 0, CTXT )
      CALL BLACS_GRIDINIT( CTXT, 'R', NPROW, NPCOL )
      CALL BLACS_GRIDINFO( CTXT, NPROW, NPCOL, MYROW, MYCOL )
*
*       ,
*    
*
      IF( MYROW.GE.NPROW .OR. MYCOL.GE.NPCOL ) GO TO 20
*
       NP = NUMROC( N, NB, MYROW, 0, NPROW )
       NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
       NQRHS = NUMROC( NRHS, NB, MYCOL, 0, NPCOL )
*
*     A, AF,   X
*
      CALL DESCINIT( DESCA, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
      CALL DESCINIT(DESCB, N, NRHS,NB,NBRHS, 0,0, CTXT,MAX(1,NP),INFO)
      CALL DESCINIT(DESCX, N, NRHS,NB,NBRHS, 0,0, CTXT,MAX(1,NP),INFO)
      CALL DESCINIT(DESCAF, N, N, NB, NB, 0, 0, CTXT, MAX(1,NP), INFO)
*
*     AMEM
*
*     A
      IPA = 1
*
*    ()   B
*
      IPB = IPA + DESCA( 9 )*NQ
*
*      
*   
*
      IPPIV = IPB + DESCB( 9 )*NQRHS
      LIPIV = ICEIL( 4*(NP+NB), 8 )
      IPW =IPPIV + MAX( NP, LIPIV )
*
      IF( NAME .NE. 'PZGESV3' ) GOTO 1
*
      IPAF = IPPIV + MAX( NP, LIPIV )
      IPX = IPAF + DESCAF( 9 )*NQ
*
      IPFER = IPX + DESCX( 9 )*NQRHS
      IPBER = IPFER + DESCX(9)*NQRHS
      IPWOR = IPBER + DESCX(9)*NQRHS
*
      NQB = ICEIL( N, NB*NPCOL )
      LCM = ILCM( NPROW, NPCOL )
      LCMQ = LCM / NPCOL
*
*   ,    PZGESV3
*
      LWORK = 4*NP + NQ + ICEIL(NQB, LCMQ)*NB
      LIWORK = MAX( 2*NQ, NP )
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
      GO TO 3
*
    1 IF( NAME .NE. 'PZGESV2' ) GOTO 7
*
      IPWOR =IPPIV + MAX( NP, LIPIV )
*
*   ,    PZGESV2
*
      LWORK = 2*NP + 2*NQ
     $       + MAX(2, MAX(NB*MAX(1, ICEIL(NPROW-1, NPCOL)),
     $                   NQ + NB*MAX(1, ICEIL(NPCOL-1, NPROW))))
      LIWORK = MAX( 2*NQ, NP )
*
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
      GOTO 3
    7 IF( NAME .NE. 'PZGESV' .AND. NAME .NE. 'PZGESV1') GOTO 10
      GO TO 3
*
*     PZLAPRNT  .
*
    3 WORKSIZ = MAX( NB, NP )
*
      INFO = 0
      MMIN = IPW + WORKSIZ
*
*      ( MMIN )
*
      IF(IPW + WORKSIZ .GT. MEMSIZE ) THEN
         IF( IAM .EQ. 0 ) WRITE( NPR, FMT = * )'  '
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 ) WRITE( NOUT, FMT = * )'  '
         INFO = 1
      END IF
*
*   INFO    
*
      CALL IGSUM2D( CTXT, 'All', ' ', 1, 1, INFO, 1, -1, 0 )
      IF( INFO .GT. 0 ) THEN
         OPEN( NOUT, FILE = OUTFILE, STATUS = 'UNKNOWN' )
         IF( IAM .EQ. 0 )
     $       WRITE( NOUT, FMT = * ) '   '
         GO TO 10
      END IF
*
*   
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )N, N, NB, NB
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL
         WRITE( NPR, FMT = * ) '     '
         WRITE( NPR, FMT = * )'   IPA,   IPB,   IPPIV, IPW,  MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPB, IPPIV, IPW, MMIN
*
         IF( NAME .NE. 'PZGESV3' ) GOTO 4
         WRITE( NPR, FMT = * )'   IPAF,   IPX, IPFER,   IPBER, IPWOR'
         WRITE( NPR, FMT = 9994 )IPAF, IPX, IPFER, IPBER, IPWOR
    4    IF( NAME .EQ. 'PZGESV' ) GOTO 5
         WRITE( NPR, FMT = 9983 ) TRANS
    5    WRITE( NPR, FMT = * ) '  DESCA'
         WRITE( NPR, FMT = 9985 )DESCA
         WRITE( NPR, FMT = * ) '  DESCB'
         WRITE( NPR, FMT = 9985 )DESCB
         WRITE( NPR, FMT = * ) '  DESCX'
         WRITE( NPR, FMT = 9985 )DESCX
         IF( NAME .NE. 'PDGESV3' ) GOTO 2
         WRITE( NPR, FMT = * ) '  DESCAF'
         WRITE( NPR, FMT = 9985 )DESCAF
    2    WRITE( NPR, FMT = * ) '  A'
      END IF
*
 9994 FORMAT( / 5I7 /)
 9983 FORMAT( / 'TRANS = ', A /)
 9985 FORMAT( / 9I5 /)
*
*        A  B
*
      CALL PZLAREAD(INFILEA, AMEM(IPA), DESCA, 0, 0, AMEM(IPW))
      CALL PZLAREAD(INFILEB, AMEM(IPB), DESCB, 0, 0, AMEM(IPW))
*
      CALL PZLAPRNT( N, N, AMEM(IPA), IA, JA, DESCA, 0, 0, 'A',
     $               NPR, AMEM( IPW ) )
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  B'
      END IF
*
      CALL PZLAPRNT( N, NRHS, AMEM(IPB), IB, JB, DESCB, 0, 0, 'B',
     $               NPR, AMEM( IPW ) )
*
*    A * X = B
*
      IF( NAME .EQ. 'PZGESV1' ) GOTO 11
      IF( NAME .EQ. 'PZGESV2' ) GOTO 12
      IF( NAME .EQ. 'PZGESV3' ) GOTO 14
      IF( NAME .NE. 'PZGESV' ) GOTO 10
*
      CALL PZGESV( N, NRHS, AMEM(IPA), IA, JA, DESCA, AMEM(IPPIV),
     $              AMEM(IPB), IB, JB, DESCB, INFO )
      GOTO 99
*
   11 CALL PZGESV1( TRANS, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPPIV), AMEM(IPB), IB, JB, DESCB, INFO )
      GOTO 99
*
   12 CALL PZGESV2( TRANS, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPPIV), AMEM(IPB), IB, JB, DESCB,
     $              RCOND, AMEM(IPWOR), LWORK, AMEM(IPIWOR),
     $              LIWORK, INFO)
      GOTO 99
*
   14 CALL PZGESV3( TRANS, N, NRHS, AMEM(IPA), IA, JA, DESCA,
     $              AMEM(IPAF),IAF, JAF, DESCAF, AMEM(IPPIV),
     $              AMEM(IPB), IB, JB, DESCB, AMEM(IPX), IX,JX,DESCX,
     $              AMEM(IPFER), AMEM(IPBER),   
     $              AMEM(IPWOR), LWORK, AMEM(IPIWOR), LIWORK, INFO)
      GOTO 99
*           
*   X
*
   99 IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = * ) '  '
      IF( NAME .NE. 'PZGESV2' ) GOTO 18
         WRITE( NPR, FMT = 9995 )INFO, RCOND
         GO TO 19
   18    WRITE( NPR, FMT = 9996 )INFO
*         WRITE( NPR, FMT = 9984 )AMEM(IPW)
   19    WRITE( NPR, FMT = * ) '   X'
      END IF
*
      IF( NAME .NE. 'PZGESV3' ) GOTO 15
*
      CALL PZLAPRNT( N, NRHS, AMEM(IPX), IX,JX, DESCX, 0, 0, 'X',NPR,
     $               AMEM( IPW ) )
      GO TO 17
*
   15 CALL PZLAPRNT( N, NRHS, AMEM(IPB), IB,JB, DESCB, 0, 0, 'X',NPR,
     $               AMEM( IPW ) )
*
*     
*
   17 IF( NAME .NE. 'PZGESV3' ) GOTO 16
*
      CALL PZLAWRITE( OUTFILE, N, NRHS, AMEM(IPX), 1, 1, DESCX,
     $                0, 0, AMEM(IPW) )
      GO TO 10
*
   16 CALL PZLAWRITE( OUTFILE, N, NRHS, AMEM(IPB), 1, 1, DESCB,
     $                0, 0, AMEM(IPW) )
*
   10 CONTINUE
*
      CALL BLACS_GRIDEXIT( CTXT )
   20 CONTINUE
*
      IF( IAM .EQ. 0 ) THEN
         IF( NOUT .NE. 6 .AND. NOUT .NE. 0 ) CLOSE( NOUT )
      END IF
*
      CALL BLACS_EXIT( 0 )
*
 9992 FORMAT( / '    ', A7 )
 9998 FORMAT(/'  A X = B ,'//'  A -   ',I2,
     $       ' ',I2,',',
     $       /'        ', I2, '  ', I2, /)
 9997 FORMAT( / '   ', I2, ' ,',
     $       '    ', I2, '  ', I2 /)
 9995 FORMAT( / '  INFO =', I6, '   RCOND  = ', E16.8 /)
 9996 FORMAT( / '  INFO  = ', I6 /)
      RETURN
      END
